import xml.etree.ElementTree as ET
import os,re
import csv

def genPuzzlesRoot(folder):
    for directory in os.listdir(folder):
        newFolder = os.path.join(folder,directory)
        if (os.path.exists(os.path.join(newFolder,"images"))):    
            genPuzzle(os.path.join(newFolder,"images"))
        else:
            genPuzzle(newFolder)

        
def genPuzzle(folder):
    for root, dirs, files in os.walk(folder, topdown=True):
        if len(files) > 0:
            puzzle_name = os.path.basename(root)
            f2 = os.path.split(os.path.split(root)[0])[1]
            #path = f2 + "/" + puzzle_name + "/"
            path = root.split("global\\")[1] + "\\"
            #import pdb;pdb.set_trace()
            section_bg = [ f for f in files if "_bg" in f][0]
			#section_icon = [ f for f in files if "sec_" in f][0]
            section_icon = "sec_" + section_bg.replace("_bg","")
            puz_name =  section_bg.replace("_bg","").replace(".png","")
            print ('<puzzle name="%s" section_icon="%s" bg="%s" selector_bg="backgrounds/bg_2.png" >' %(puz_name,path +section_icon,path +section_bg))
            print('\t<images>')
            file_pattern = re.search(r'([-\w]*)_([-\w]+)\.\w+',files[7]).groups()[0]
            
            for i in range(1,len(files)-2,2): 
                original = path + file_pattern + "_" +str(i) + ".png"
                shadow = path + file_pattern + "_" +str(i+1) + ".png"
                print ('\t\t <pair original="%s"  shadow="%s" />' %(original , shadow))
            print('\t</images>')
            print('</puzzle>')   

def getSoundFiles(csvFile):
    sounds = []
    with open(csvFile, 'rb') as csvfile:
         spamreader = csv.reader(csvfile, delimiter=' ', quotechar='|')
         for row in spamreader:
            data = row[0].split(",")
            if len(data) == 2:
                sounds.append(data[1])
            else:
                sounds.append(data[1])
                sounds.append(data[2])
    return sounds
    
def parseSounds(csvFile):
    sounds = {}
    with open(csvFile, 'rb') as csvfile:
         spamreader = csv.reader(csvfile, delimiter=' ', quotechar='|')
         for row in spamreader:
            data = row[0].split(",")
            if len(data) == 2:
                sounds[data[0]] = "audio/"+data[1]+".mp3"
            else:
                sounds[data[0]] = "audio/"+data[2]+".mp3" + "," + "audio/"+data[1]+".mp3"
    return sounds

def fixX(xmlFile):
    tree = ET.parse(xmlFile)
    root = tree.getroot()
    positioners = root.findall("./puzzles//positioner")
    for pos in  positioners:
        pos.set("x","199")
        for obj in pos.findall("./object"):
            x = float(obj.get("x")) - 199
            obj.set("x",str(x))
    tree.write(r"c:\temp\new_xml.xml")
    
def parseXml(csvFile,xmlFile):
    sounds = parseSounds(csvFile)
    tree = ET.parse(xmlFile)
    root = tree.getroot()
    for pair in root.iter('pair'):
        splits = pair.attrib["original"].split("/")
        key = splits[len(splits)-1].replace(".png","")
        if key in sounds.keys():
            pair.set("sound",sounds[key])
            print pair.attrib
    tree.write(r"c:\temp\new_xml.xml")
    
def getAudioFiles(folder,ext="mp3"):
    audioFiles=[]
    for root, dirs, files in os.walk(folder, topdown=True):
        for file in files:
            if not file.endswith(ext):
                continue
            audioFiles.append(file.replace(".mp3",""))
    return audioFiles
    
def findMissingFiles(sourceFilesCsv,destFolder1,destFolder2):
    sourceSounds = getSoundFiles(sourceFilesCsv)
    s1=getAudioFiles(destFolder1)
    s2=getAudioFiles(destFolder2)
    existentSounds = s1 + s2
    print sorted(sourceSounds) 
    print "\n\n"
    print sorted(existentSounds)
    for file in sourceSounds:
        if file not in existentSounds:
            print file
            

